/**
 * Blinking Box In Processing By Jonathan Ohayon  
 * 
 * Presents a rotating white box. If you are pressing the button attached to your arduino,
 * the box is blinking. If you are not pressing it, it stops blinking.
 * 
 * Some elements taken from the On/Off example from Processing IDE, and some taken from
 * the Knock template by Arduino team (for Processing).
 *
 * Arduino script (By Arduino team):   
 * https://drive.google.com/file/d/0B9dCFro40J0JRFFPSDJNc2FPOWs/edit?usp=sharing
 */
 

import processing.serial.*;

float spin = 0.0;
String buff = "";
int NEWLINE = 10;
int val = 0;

Serial port;

void setup() {
  size(640, 360, P3D);
  noStroke();
   port = new Serial(this, "COMXX", 9600); //**IMPORTENT!!!!>> Change the XX to the port number in Aruino IDE
}

void draw() {
  while (port.available() > 0) {
    serialEvent(port.read());
    lights();
  }
  
  background(51);
  
  
  spin += 0.001;
  
  pushMatrix();
  translate(width/2, height/2, 0);
  rotateX(PI/9);
  rotateY(PI/5 + spin);
  box(150);
  popMatrix();
}

void serialEvent(int serial) 
{ 
  if(serial != NEWLINE) { 
    buff += char(serial);
  } else {
    buff = buff.substring(1, buff.length()-1);
    if (val == 0) {
      val = 255;
    } else {
      val = 0;
    }
    println(buff);
    // Clear the value of "buff"
    buff = "";
   }
}

